<?php

/**
 * komunikacja_wersje actions.
 *
 * @package    sam3
 * @subpackage komunikacja_wersje
 * @author     Maciej Kamiński
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class komunikacja_wersjeActions extends sfActions
{
  public function preExecute()
  {
    $perm = ($this->getUser()->checkPermission('ikom','edit')==1)?true:false;
    if(!$perm || !in_array('ikom', ModulPeer::getEnabled()))$this->forward(sfConfig::get('sf_secure_module'),sfConfig::get('sf_secure_action'));
  }

  public function executeIndex(sfWebRequest $request)
  {
    $this->komunikacja_wersje_list = KomunikacjaWersjePeer::doSelect(new Criteria());
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new KomunikacjaWersjeForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new KomunikacjaWersjeForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($komunikacja_wersje = KomunikacjaWersjePeer::retrieveByPk($request->getParameter('id')), sprintf('Object komunikacja_wersje does not exist (%s).', $request->getParameter('id')));
    $this->form = new KomunikacjaWersjeForm($komunikacja_wersje);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($komunikacja_wersje = KomunikacjaWersjePeer::retrieveByPk($request->getParameter('id')), sprintf('Object komunikacja_wersje does not exist (%s).', $request->getParameter('id')));
    $this->form = new KomunikacjaWersjeForm($komunikacja_wersje);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($komunikacja_wersje = KomunikacjaWersjePeer::retrieveByPk($request->getParameter('id')), sprintf('Object komunikacja_wersje does not exist (%s).', $request->getParameter('id')));
    $komunikacja_wersje->delete();
    $this->getUser()->setFlash('notice', 'Poprawnie usunięto wersję.');
    $this->redirect('komunikacja_wersje/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $komunikacja_wersje = $form->save();
      $this->getUser()->setFlash('notice', 'Poprawnie zapisano dane wersji.');
      $this->redirect('komunikacja_wersje/edit?id='.$komunikacja_wersje->getId());
    }
  }

  public function executeZapiszaktywna(sfWebRequest $request)
  {
      $portal = sfConfig::get('portal');
      $wersja_robocza = UstawieniePeer::retrieveByPK('ikom_robocza_admin',$portal->getId());
      $wersja_robocza->setTresc($request->getParameter('wersja_id'));
      $wersja_robocza->save();

      $this->getUser()->setFlash('notice', 'Poprawnie zmieniono wersję roboczą.');

      $this->redirect('komunikacja/linie');
  }
}
