<?php

class KomunikacjaSzukajForm extends sfForm {

    public function configure() {
        
        $this->widgetSchema['query'] = new sfWidgetFormInput();
        $this->validatorSchema['query'] = new sfValidatorString(array('max_length' => 255, 'required' => false));

        $c = new Criteria();
        $c->add(KwiatyPeer::STATUS, 0);

        $this->widgetSchema['wiata'] = new sfWidgetFormPropelChoice(array(
            'model' => 'Kwiaty',
            'add_empty' => true,
            'key_method' => '__toString',
            'criteria' => $c,
        ));

        $c = new Criteria();
        $c->add(KtabliczkiPeer::STATUS, 0);
        $c->add(KtabliczkiPeer::WERSJA_ID, KomunikacjaWersjePeer::getCurrentVersions(), Criteria::IN);
        $c->addGroupByColumn(KtabliczkiPeer::LINIA);

        $this->widgetSchema['linia'] = new sfWidgetFormPropelChoice(array(
            'model' => 'Ktabliczki',
            'add_empty' => true,
            'method' => 'getLinia',
            'key_method' => 'getLinia',
            'criteria' => $c,
        ));
    
        $this->widgetSchema->setLabels(array(
            'wiata' => 'Wiata',
            'linia' => 'Linia',
        ));
        
        $this->widgetSchema->setNameFormat('search[%s]');
        $hash_id = $this->getOption('hash_id');
//        $this->getWidgetSchema()->setNameFormat('search[%s]');        
        $this->getWidgetSchema()->setIdFormat('search'.( $hash_id ? '_'.$hash_id : '').'_%s');
        
        $this->setRequiredFields();
    }

    public function bind(array $taintedValues = null, array $taintedFiles = null) {
        
    }
}

?>