<?php

/**
 * komunikacjainfo actions.
 *
 * @package    sam3
 * @subpackage komunikacjainfo
 * @author     Maciej Kamiński
 * @version    SVN: $Id: actions.class.php 12479 2008-10-31 10:54:40Z fabien $
 */
class komunikacjainfoActions extends sfActions
{
  public function preExecute()
  {
    if (!in_array('ikom', ModulPeer::getEnabled())) {
        $this->redirect('@homepage');
    }
	$_SESSION['menu_sel'] = 'komunikacjainfo';
  }

   public function executeIndex(sfWebRequest $request)
  {
	$c = new Criteria();

	if($request->isMethod('post')) {
        $values = $request->getParameter('search');
        $temp = array();
        foreach ($values as $key=>$value) {
            $value = strip_tags($value);
            $temp[$key] = $value;
        }
        $values = $temp;
        //pola wyszukiwarki dla modułu komunikacji
        $this->getUser()->setAttribute('ikom_search_values', $values);

        //globalne pole wyszukiwarki
        $this->getUser()->setAttribute('global_query', $values['query'], 'search');
    }
	else {
        $values = $this->getUser()->getAttribute('ikom_search_values');
	}

	if(isset($values['query']) && $values['query'] != '') {
        $c->add(KtabliczkiPeer::NAZWAPRZYSTANKU, '%'.$values['query'].'%', Criteria::LIKE);
	}

	if(isset($values['wiata']) && $values['wiata']!='') {
        $c->add(KtabliczkiPeer::NAZWAPRZYSTANKU, $values['wiata']);
    }
	if(isset($values['linia']) && $values['linia']!='') {
        $c->add(KtabliczkiPeer::LINIA, $values['linia']);
    }

	$link = array();
	if($request->isMethod('get')){
			if($request->getParameter('nazwaprzystanku')){
				$c->add(KtabliczkiPeer::NAZWAPRZYSTANKU, $request->getParameter('nazwaprzystanku'));
				$link[] = 'nazwaprzystanku='.$request->getParameter('nazwaprzystanku');
			}

			if($request->getParameter('linia')!=''){
				$c->add(KtabliczkiPeer::LINIA, $request->getParameter('linia'));
				$link[] = 'linia='.$request->getParameter('linia');
        }
	}


		$c->add(KtabliczkiPeer::WERSJA_ID,  KomunikacjaWersjePeer::getCurrentVersions(), Criteria::IN);
		$c->add(KtabliczkiPeer::STATUS, 0);


		if($request->getParameter('sel')!=''){
            $link[] = 'sel='.$request->getParameter('sel');
        }


  		$pager = new sfPropelPager('Ktabliczki', sfConfig::get('app_pages'));
		$pager->setCriteria($c);
		$pager->setPage($this->getRequestParameter('page', 1));
		$pager->init();

		foreach($pager->getResults() as $przystanek):
			$wiata_temp = new KwiatyPeer();
			$d = new Criteria();
			$d->add(KwiatyPeer::NAZWAWIATY, $przystanek->getNazwaprzystanku());
			$wiata = $wiata_temp->doSelectOne($d);

			//jezeli przystanek nie ma zdefiniowanej wlasnej lokalizacji
			if(!$przystanek->getLokX() && !$przystanek->getLokY() && !$przystanek->getLokZ()){
				if($wiata->getLokX() && $wiata->getLokY() && $wiata->getLokZ()){
					$przystanek->setLokX($wiata->getLokX());
					$przystanek->setLokY($wiata->getLokY());
					$przystanek->setLokZ($wiata->getLokZ());
				}

			}
			if(!$przystanek->getIkona()){
				if($wiata->getIkona()){
					$przystanek->setIkona($wiata->getIkona());
				}
			}
			if(!$przystanek->getKomunikat()){
				if($wiata->getKomunikat()){
					$przystanek->setKomunikat($wiata->getKomunikat());
				}
			}
		endforeach;

		$this->pager = $pager;
		$this->link = implode('&',$link);

  }
  public function executeKierunki(sfWebRequest $request)
  {
  	//wyciąga z bazy listę kierunków dla danej linii
  	$kierunki = new KtabliczkiPeer();
  	$c = new Criteria();
  	$c->add(KtabliczkiPeer::STATUS, 0);
	$c->add(KtabliczkiPeer::WERSJA_ID,  KomunikacjaWersjePeer::getCurrentVersions(), Criteria::IN);
  	$c->add(KtabliczkiPeer::LINIA, $request->getParameter('linia'));
  	$c->addGroupByColumn(KtabliczkiPeer::KIERUNEK);
  	$this->kierunki_list =  $kierunki->doSelect($c);
  }

  public function executeKierunkiclose(sfWebRequest $request)
  {
  	//wyciąga z bazy listę przystanków i przebiegów dla danej linii i kierunku- wykorzystywane do chowania ikon i przebiegow
  	$przystanki = new KtabliczkiPeer();
  	$c = new Criteria();
  	$c->add(KtabliczkiPeer::STATUS, 0);
	$c->add(KtabliczkiPeer::WERSJA_ID,  KomunikacjaWersjePeer::getCurrentVersions(), Criteria::IN);
  	$c->add(KtabliczkiPeer::LINIA, $request->getParameter('linia'));
  	$c->add(KtabliczkiPeer::KIERUNEK, $request->getParameter('kierunek'));
  	//$c->addGroupByColumn(KtabliczkiPeer::KIERUNEK);
  	$this->przystanki_list =  $przystanki->doSelect($c);

   	/* ------ kilka dodatkowych przydatnych zmiennych ----- */
  	$this->linia = $request->getParameter('linia');
	$this->kierunek = $request->getParameter('kierunek');

  }

  public function executePrzystanki(sfWebRequest $request)
  {
      $temp = KtabliczkiPeer::retrieveByPK($request->getParameter('kierunek'));
  	//wyciąga z bazy listę przystanków dla danej linii i kierunku
  	$przystanki = new KtabliczkiPeer();
  	$c = new Criteria();
  	$c->add(KtabliczkiPeer::STATUS, 0);
	$c->add(KtabliczkiPeer::WERSJA_ID,  KomunikacjaWersjePeer::getCurrentVersions(), Criteria::IN);
  	$c->add(KtabliczkiPeer::LINIA, $request->getParameter('linia'));
  	$c->add(KtabliczkiPeer::KIERUNEK,$temp->getKierunek());
	$c->addAscendingOrderByColumn(KtabliczkiPeer::KOLEJNOSC);
  	//$this->przystanki_list =  $przystanki->doSelect($c);

	$przystanki_list =  $przystanki->doSelect($c);
  	foreach($przystanki_list as $przystanek):
  		$wiata_temp = new KwiatyPeer();
  		$c = new Criteria();
  		$c->add(KwiatyPeer::NAZWAWIATY, $przystanek->getNazwaprzystanku());
  		$wiata = $wiata_temp->doSelectOne($c);

        //jezeli przystanek nie ma zdefiniowanej wlasnej lokalizacji
        if(!$przystanek->getLokX() && !$przystanek->getLokY() && !$przystanek->getLokZ()){
            if($wiata->getLokX() && $wiata->getLokY() && $wiata->getLokZ()){
                $przystanek->setLokX($wiata->getLokX());
                $przystanek->setLokY($wiata->getLokY());
                $przystanek->setLokZ($wiata->getLokZ());
            }

        }
        if(!$przystanek->getIkona()){
        	if($wiata->getIkona()){
        		$przystanek->setIkona($wiata->getIkona());
        	}
        }
		if(!$przystanek->getKomunikat()){
			if($wiata->getKomunikat()){
				$przystanek->setKomunikat($wiata->getKomunikat());
			}
		}

  	endforeach;

  	$this->przystanki_list = $przystanki_list;



   	/* ------ kilka dodatkowych przydatnych zmiennych ----- */
  	$this->linia = $request->getParameter('linia');
	$this->kierunek = $request->getParameter('kierunek');
  }

	public function executeTabliczka(sfWebRequest $request)
  	//wyciaga dane pojedynczej tabliczki
  	{
		$tabliczka = KtabliczkiPeer::retrieveByPk($request->getParameter('id'));

		$wiata_temp = new KwiatyPeer();
		$d = new Criteria();
		$d->add(KwiatyPeer::NAZWAWIATY, $tabliczka->getNazwaprzystanku());
		$wiata = $wiata_temp->doSelectOne($d);
		//jezeli przystanek nie ma zdefiniowanej wlasnej lokalizacji
        if(!$tabliczka->getLokX() && !$tabliczka->getLokY() && !$tabliczka->getLokZ()){
            if($wiata->getLokX() && $wiata->getLokY() && $wiata->getLokZ()){
                $tabliczka->setLokX($wiata->getLokX());
                $tabliczka->setLokY($wiata->getLokY());
                $tabliczka->setLokZ($wiata->getLokZ());
            }

        }
        if(!$tabliczka->getIkona()){
        	if($wiata->getIkona()){
        		$tabliczka->setIkona($wiata->getIkona());
        	}
        }
		if(!$tabliczka->getKomunikat()){
			if($wiata->getKomunikat()){
				$tabliczka->setKomunikat($wiata->getKomunikat());
			}
		}
  		$this->tabliczka = $tabliczka;

		//odnalezienie nastepnego i poprzedniego przystanku
		$kierunek = new KtabliczkiPeer();
		$c = new Criteria();
		$c->add(KtabliczkiPeer::LINIA, $tabliczka->getLinia());
		$c->add(KtabliczkiPeer::KIERUNEK, $tabliczka->getKierunek());
		$c->add(KtabliczkiPeer::WERSJA_ID, $tabliczka->getWersjaId());
		$c->add(KtabliczkiPeer::STATUS, 0);
		$c->addAscendingOrderByColumn(KtabliczkiPeer::KOLEJNOSC);

		$kierunek_temp = array();
		$kierunek_list = $kierunek->doSelect($c);
		foreach($kierunek_list as $kierunek):
			$kierunek_temp[] = $kierunek->getId();
		endforeach;

		$aktualna = array_search($tabliczka->getId(), $kierunek_temp);

		//nastepny przystanek
		if(($aktualna+1)<sizeof($kierunek_temp)){
			$this->nastepna = $kierunek_temp[$aktualna+1];
		}
		else{
			$this->nastepna = false;
		}
		//poprzedni przystanek
		if(($aktualna-1)>=0){
			$this->poprzednia = $kierunek_temp[$aktualna-1];
		}
		else{
			$this->poprzednia = false;
		}
  	}

	public function executeTabliczkaajax(sfWebRequest $request)
  	//wyciaga dane pojedynczej tabliczki do wyswietlenia ajaxem
  	{
  		$tabliczka = KtabliczkiPeer::retrieveByPk($request->getParameter('id'));

		$wiata_temp = new KwiatyPeer();
		$d = new Criteria();
		$d->add(KwiatyPeer::NAZWAWIATY, $tabliczka->getNazwaprzystanku());
		$wiata = $wiata_temp->doSelectOne($d);
		//jezeli przystanek nie ma zdefiniowanej wlasnej lokalizacji
        if(!$tabliczka->getLokX() && !$tabliczka->getLokY() && !$tabliczka->getLokZ()){
            if($wiata->getLokX() && $wiata->getLokY() && $wiata->getLokZ()){
                $tabliczka->setLokX($wiata->getLokX());
                $tabliczka->setLokY($wiata->getLokY());
                $tabliczka->setLokZ($wiata->getLokZ());
            }

        }
        if(!$tabliczka->getIkona()){
        	if($wiata->getIkona()){
        		$tabliczka->setIkona($wiata->getIkona());
        	}
        }
		if(!$tabliczka->getKomunikat()){
			if($wiata->getKomunikat()){
				$tabliczka->setKomunikat($wiata->getKomunikat());
			}
		}

  		$this->tabliczka = $tabliczka;

		//odnalezienie nastepnego i poprzedniego przystanku
		$kierunek = new KtabliczkiPeer();
		$c = new Criteria();
		$c->add(KtabliczkiPeer::LINIA, $tabliczka->getLinia());
		$c->add(KtabliczkiPeer::KIERUNEK, $tabliczka->getKierunek());
		$c->add(KtabliczkiPeer::WERSJA_ID, $tabliczka->getWersjaId());
		$c->add(KtabliczkiPeer::STATUS, 0);
		$c->addAscendingOrderByColumn(KtabliczkiPeer::KOLEJNOSC);

		$kierunek_temp = array();
		$kierunek_list = $kierunek->doSelect($c);
		foreach($kierunek_list as $kierunek):
			$kierunek_temp[] = $kierunek->getId();
		endforeach;

		$aktualna = array_search($tabliczka->getId(), $kierunek_temp);

		//nastepny przystanek
		if(($aktualna+1)<sizeof($kierunek_temp)){
			$this->nastepna = $kierunek_temp[$aktualna+1];
		}
		else{
			$this->nastepna = false;
		}
		//poprzedni przystanek
		if(($aktualna-1)>=0){
			$this->poprzednia = $kierunek_temp[$aktualna-1];
		}
		else{
			$this->poprzednia = false;
		}
  	}

  	public function executeBlank()
  	{

  	}

	public function executeGetSearchForm(sfWebRequest $request)
 	{
        $this->values = $this->getUser()->getAttribute('ikom_search_values');

        //$this->disp = $request->getParameter('disp');
        $this->disp = $request->getCookie('show_search')?'block':'none';
        $this->form = new KomunikacjaSzukajForm($this->values);
        $this->form->setDefault('query', $this->getUser()->getAttribute('global_query', null, 'search'));

 	}

}
