<?php

/**
 * mapa actions.
 *
 * @package    sam3
 * @subpackage mapa
 * @author     Alfred Broda
 * @version    SVN: $Id: actions.class.php 9301 2008-05-27 01:08:46Z dwhittle $
 */
class komunikacjamapaActions extends sfActions
{
 /**
  * Executes index action
  *
  * @param sfRequest $request A request object
  */
  public function preExecute()
  {
       if (!in_array('ikom', ModulPeer::getEnabled())) {
            $this->redirect('@homepage');
        }
        $culture = $this->getUser()->getCulture();
        $response = $this->getResponse();
        Functions::setAllMetasFromDb('mapa', $response,  $culture);

        $request = $this->getRequest();
        $user = $this->getUser();
        Functions::changeLang($request, $user);

        $mapa_config = UstawieniePeer::getProperties('info_config');
        //sprawdzam czy zostały ustawione dwa skrajne wierzcholki
        $mapa_config['all_bounds'] = false;
        if(isset($mapa_config['nw_lat'])) {
            if($mapa_config['nw_lat'] && $mapa_config['nw_lon'] && $mapa_config['se_lat'] && $mapa_config['se_lon']) {
                $mapa_config['all_bounds'] = true;
            }
        }
        $this->mapa_config = $mapa_config;
    }

  public function executeIndex(sfWebRequest $request)
  {
      $def = UstawieniePeer::getProperties('info_config');

      $this->defx = $this->actx = $def['x'];
      $this->defy = $this->acty = $def['y'];
      $this->defz = $this->zoom = $def['zoom'];

  }

  public function executeKierunki(sfWebRequest $request)
  {
  	//wyciąga z bazy listę kierunków dla danej linii
  	$kierunki = new KtabliczkiPeer();
  	$c = new Criteria();
  	$c->add(KtabliczkiPeer::LINIA, $request->getParameter('linia'));
  	$c->add(KtabliczkiPeer::WERSJA_ID,  KomunikacjaWersjePeer::getCurrentVersions(), Criteria::IN);
	$c->add(KtabliczkiPeer::STATUS, 0);
  	$c->addGroupByColumn(KtabliczkiPeer::KIERUNEK);
  	$this->kierunki_list =  $kierunki->doSelect($c);
  }

	public function executeLiniaclose(sfWebRequest $request)
    {
  	//wyciąga z bazy listę przystanków i przebiegów dla danej linii żeby pozamykać linie i markery
  	$przystanki = new KtabliczkiPeer();
  	$c = new Criteria();
  	$c->add(KtabliczkiPeer::LINIA, $request->getParameter('linia'));
	$c->add(KtabliczkiPeer::WERSJA_ID,  KomunikacjaWersjePeer::getCurrentVersions(), Criteria::IN);
  	$c->add(KtabliczkiPeer::STATUS, 0);
  	$this->przystanki_list =  $przystanki->doSelect($c);

	/* ----- dane do wyrysowania przebiegu trasy dla danej linii  ----- */
  	$this->trasy = $this->getTrasy($request->getParameter('linia'), 'all');
  }

  public function executeKierunkiclose(sfWebRequest $request)
  {
      $temp = KtabliczkiPeer::retrieveByPK($request->getParameter('kierunek'));

  	//wyciąga z bazy listę przystanków i przebiegów dla danej linii i kierunku- wykorzystywane do chowania ikon i przebiegow
  	$przystanki = new KtabliczkiPeer();
  	$c = new Criteria();
  	$c->add(KtabliczkiPeer::LINIA, $request->getParameter('linia'));
	$c->add(KtabliczkiPeer::WERSJA_ID,  KomunikacjaWersjePeer::getCurrentVersions(), Criteria::IN);
  	$c->add(KtabliczkiPeer::STATUS, 0);
  	$c->add(KtabliczkiPeer::KIERUNEK, $temp->getKierunek());
  	//$c->addGroupByColumn(KtabliczkiPeer::KIERUNEK);
  	$this->przystanki_list =  $przystanki->doSelect($c);

   	/* ------ kilka dodatkowych przydatnych zmiennych ----- */
  	$this->linia = $request->getParameter('linia');
	$this->kierunek = $request->getParameter('kierunek');

	/* ----- dane do wyrysowania przebiegu trasy dla danej linii i kierunku ----- */
  	$this->trasy = $this->getTrasy($request->getParameter('linia'), $temp->getKierunek());
  }

  public function executePrzystanki(sfWebRequest $request)
  {
      $temp = KtabliczkiPeer::retrieveByPK($request->getParameter('kierunek'));

  	//wyciąga z bazy listę przystanków dla danej linii i kierunku
  	$przystanki = new KtabliczkiPeer();
  	$c = new Criteria();
  	$c->add(KtabliczkiPeer::LINIA, $request->getParameter('linia'));
  	$c->add(KtabliczkiPeer::KIERUNEK, $temp->getKierunek());
	$c->add(KtabliczkiPeer::WERSJA_ID,  KomunikacjaWersjePeer::getCurrentVersions(), Criteria::IN);
  	$c->add(KtabliczkiPeer::STATUS, 0);
	$c->addAscendingOrderByColumn(KtabliczkiPeer::KOLEJNOSC);
  	//$c->addGroupByColumn(KtabliczkiPeer::KIERUNEK);
  	//$this->przystanki_list =  $przystanki->doSelect($c);

  	//sprawdzenie ustawien przystankow z tabeli wiat
  	$przystanki_list =  $przystanki->doSelect($c);
  	foreach($przystanki_list as $przystanek):
  		$wiata_temp = new KwiatyPeer();
  		$c = new Criteria();
  		$c->add(KwiatyPeer::NAZWAWIATY, $przystanek->getNazwaprzystanku());
  		$wiata = $wiata_temp->doSelectOne($c);

        //jezeli przystanek nie ma zdefiniowanej wlasnej lokalizacji
        if(!$przystanek->getLokX() && !$przystanek->getLokY() && !$przystanek->getLokZ()){
            if($wiata->getLokX() && $wiata->getLokY() && $wiata->getLokZ()){
                $przystanek->setLokX($wiata->getLokX());
                $przystanek->setLokY($wiata->getLokY());
                $przystanek->setLokZ($wiata->getLokZ());
            }

        }
        if(!$przystanek->getIkona()){
        	if($wiata->getIkona()){
        		$przystanek->setIkona($wiata->getIkona());
        	}
        }
  	endforeach;

  	$this->przystanki_list = $przystanki_list;

   	/* ------ kilka dodatkowych przydatnych zmiennych ----- */
  	$this->linia = $request->getParameter('linia');
	$this->kierunek = $request->getParameter('kierunek');

	/* ----- dane do wyrysowania przebiegu trasy dla danej linii i kierunku ----- */
  	$this->trasy = $this->getTrasy($request->getParameter('linia'), $temp->getKierunek());
  }


	public function getTrasy($linia, $kierunek)
 	{
  		$trasy = new KtrasyPeer();//($request->getParameter('linia'),$request->getParameter('kierunek'));
  		$c = new Criteria();
  		$c->add(KtrasyPeer::STATUS, 0);
  		$c->add(KtrasyPeer::LINIA, $linia);
  		if($kierunek!='all')
  			$c->add(KtrasyPeer::KIERUNEK, $kierunek);
  		return $trasy->doSelect($c);
  	}

  	public function executeContent(sfWebRequest $request)
  	{
 		//wyciąga z bazy dane dla pojedynczego przystanku
  		$id = $request->getParameter('przystanek_id');
  		$przystanek = KtabliczkiPeer::retrieveByPk($id);

		$wiata_temp = new KwiatyPeer();
  		$c = new Criteria();
  		$c->add(KwiatyPeer::NAZWAWIATY, $przystanek->getNazwaprzystanku());
  		$wiata = $wiata_temp->doSelectOne($c);

        //jezeli przystanek nie ma zdefiniowanej wlasnej lokalizacji
        if(!$przystanek->getLokX() && !$przystanek->getLokY() && !$przystanek->getLokZ()){
            if($wiata->getLokX() && $wiata->getLokY() && $wiata->getLokZ()){
                $przystanek->setLokX($wiata->getLokX());
                $przystanek->setLokY($wiata->getLokY());
                $przystanek->setLokZ($wiata->getLokZ());
            }

        }
        if(!$przystanek->getIkona()){
        	if($wiata->getIkona()){
        		$przystanek->setIkona($wiata->getIkona());
        	}
        }
		$this->przystanek = $przystanek;

  		//zwrocenie pozostalych linii przejezdzajacych przez ten przystanek
  		//$this->innetabliczki = $this->getInnetabliczki($request->getParameter('nazwaprzystanku'));
		$this->innetabliczki = $this->getInnetabliczki($przystanek->getNazwaprzystanku());

  	}

  	public function getInnetabliczki($nazwaprzystanku)
  	{
		//wyciaga z bazy tabliczki wlasciwe dla danego przystanku
  		$tabliczki = new KtabliczkiPeer();
  		$c = new Criteria();
  		$c->add(KtabliczkiPeer::NAZWAPRZYSTANKU, $nazwaprzystanku);
		$c->add(KtabliczkiPeer::WERSJA_ID,  KomunikacjaWersjePeer::getCurrentVersions(), Criteria::IN);
  		return $tabliczki->doSelect($c);
  	}

  	public function getIkona($nazwaprzystanku)
  	//wyciaga ikone z tabeli wiat
  	{
  		$wiaty = new KwiatyPeer();
  	 	$c = new Criteria();
  	 	$c->add(KwiatyPeer::NAZWAWIATY, $nazwaprzystanku);
  		return ($wiaty->doSelect($c));
  	}

  	public function executeTabliczka(sfWebRequest $request)
  	//wyciaga dane pojedynczej tabliczki
  	{
  		$this->tabliczka = KtabliczkiPeer::retrieveByPk($request->getParameter('id'));
  	}

  	public function executeInfo()
  	{

  	}

  	public function executeBlank()
  	{

  	}

  	public function executeGetSearchForm(sfWebRequest $request)
 	{
		$this->forward('komunikacjainfo','getSearchForm');
 	}

}
