<?php



class KtabliczkiMapBuilder implements MapBuilder {

	
	const CLASS_NAME = 'lib.model.map.KtabliczkiMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(KtabliczkiPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(KtabliczkiPeer::TABLE_NAME);
		$tMap->setPhpName('Ktabliczki');
		$tMap->setClassname('Ktabliczki');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'INTEGER', true, 11);

		$tMap->addColumn('PRZYSTANEK', 'Przystanek', 'VARCHAR', true, 20);

		$tMap->addColumn('LINIA', 'Linia', 'VARCHAR', true, 20);

		$tMap->addColumn('TABLICZKA', 'Tabliczka', 'LONGVARCHAR', false, null);

		$tMap->addColumn('NAZWAPRZYSTANKU', 'Nazwaprzystanku', 'VARCHAR', false, 255);

		$tMap->addColumn('KIERUNEK', 'Kierunek', 'VARCHAR', false, 255);

		$tMap->addColumn('LOK_X', 'LokX', 'DECIMAL', false, 19);

		$tMap->addColumn('LOK_Y', 'LokY', 'DECIMAL', false, 19);

		$tMap->addColumn('LOK_Z', 'LokZ', 'INTEGER', false, 11);

		$tMap->addColumn('KOMUNIKAT', 'Komunikat', 'LONGVARCHAR', false, null);

		$tMap->addColumn('IKONA', 'Ikona', 'VARCHAR', false, 255);

		$tMap->addColumn('STATUS', 'Status', 'INTEGER', true, 1);

		$tMap->addColumn('TYP', 'Typ', 'VARCHAR', false, 255);

		$tMap->addColumn('KOLEJNOSC', 'Kolejnosc', 'INTEGER', true, 11);

		$tMap->addForeignKey('WERSJA_ID', 'WersjaId', 'INTEGER', 'komunikacja_wersje', 'ID', true, 11);

	} 
} 