<?php



class KwiatyMapBuilder implements MapBuilder {

	
	const CLASS_NAME = 'lib.model.map.KwiatyMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(KwiatyPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(KwiatyPeer::TABLE_NAME);
		$tMap->setPhpName('Kwiaty');
		$tMap->setClassname('Kwiaty');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'INTEGER', true, 11);

		$tMap->addColumn('NAZWAWIATY', 'Nazwawiaty', 'VARCHAR', true, 255);

		$tMap->addColumn('LOK_X', 'LokX', 'DECIMAL', false, 19);

		$tMap->addColumn('LOK_Y', 'LokY', 'DECIMAL', false, 19);

		$tMap->addColumn('LOK_Z', 'LokZ', 'INTEGER', false, 11);

		$tMap->addColumn('KOMUNIKAT', 'Komunikat', 'LONGVARCHAR', false, null);

		$tMap->addColumn('IKONA', 'Ikona', 'VARCHAR', false, 255);

		$tMap->addColumn('STATUS', 'Status', 'INTEGER', true, 1);

	} 
} 