<?php


abstract class BaseKomunikacjaWersje extends BaseObject  implements Persistent {


  const PEER = 'KomunikacjaWersjePeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $wersja_nazwa;

	
	protected $wersja_opis;

	
	protected $wazna_od;

	
	protected $wazna_do;

	
	protected $status;

	
	protected $collKtabliczkis;

	
	private $lastKtabliczkiCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->status = 0;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getWersjaNazwa()
	{
		return $this->wersja_nazwa;
	}

	
	public function getWersjaOpis()
	{
		return $this->wersja_opis;
	}

	
	public function getWaznaOd($format = 'Y-m-d H:i:s')
	{
		if ($this->wazna_od === null) {
			return null;
		}


		if ($this->wazna_od === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->wazna_od);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->wazna_od, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getWaznaDo($format = 'Y-m-d H:i:s')
	{
		if ($this->wazna_do === null) {
			return null;
		}


		if ($this->wazna_do === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->wazna_do);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->wazna_do, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getStatus()
	{
		return $this->status;
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = KomunikacjaWersjePeer::ID;
		}

		return $this;
	} 
	
	public function setWersjaNazwa($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->wersja_nazwa !== $v) {
			$this->wersja_nazwa = $v;
			$this->modifiedColumns[] = KomunikacjaWersjePeer::WERSJA_NAZWA;
		}

		return $this;
	} 
	
	public function setWersjaOpis($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->wersja_opis !== $v) {
			$this->wersja_opis = $v;
			$this->modifiedColumns[] = KomunikacjaWersjePeer::WERSJA_OPIS;
		}

		return $this;
	} 
	
	public function setWaznaOd($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->wazna_od !== null || $dt !== null ) {
			
			$currNorm = ($this->wazna_od !== null && $tmpDt = new DateTime($this->wazna_od)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->wazna_od = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = KomunikacjaWersjePeer::WAZNA_OD;
			}
		} 
		return $this;
	} 
	
	public function setWaznaDo($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->wazna_do !== null || $dt !== null ) {
			
			$currNorm = ($this->wazna_do !== null && $tmpDt = new DateTime($this->wazna_do)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->wazna_do = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = KomunikacjaWersjePeer::WAZNA_DO;
			}
		} 
		return $this;
	} 
	
	public function setStatus($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->status !== $v || $v === 0) {
			$this->status = $v;
			$this->modifiedColumns[] = KomunikacjaWersjePeer::STATUS;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(KomunikacjaWersjePeer::STATUS))) {
				return false;
			}

			if ($this->status !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->wersja_nazwa = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->wersja_opis = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->wazna_od = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->wazna_do = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->status = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 6; 
		} catch (Exception $e) {
			throw new PropelException("Error populating KomunikacjaWersje object", $e);
		}
	}

	
	public function ensureConsistency()
	{

	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(KomunikacjaWersjePeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = KomunikacjaWersjePeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->collKtabliczkis = null;
			$this->lastKtabliczkiCriteria = null;

		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(KomunikacjaWersjePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			KomunikacjaWersjePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(KomunikacjaWersjePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			KomunikacjaWersjePeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			if ($this->isNew() ) {
				$this->modifiedColumns[] = KomunikacjaWersjePeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = KomunikacjaWersjePeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += KomunikacjaWersjePeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			if ($this->collKtabliczkis !== null) {
				foreach ($this->collKtabliczkis as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = KomunikacjaWersjePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collKtabliczkis !== null) {
					foreach ($this->collKtabliczkis as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = KomunikacjaWersjePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getWersjaNazwa();
				break;
			case 2:
				return $this->getWersjaOpis();
				break;
			case 3:
				return $this->getWaznaOd();
				break;
			case 4:
				return $this->getWaznaDo();
				break;
			case 5:
				return $this->getStatus();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = KomunikacjaWersjePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getWersjaNazwa(),
			$keys[2] => $this->getWersjaOpis(),
			$keys[3] => $this->getWaznaOd(),
			$keys[4] => $this->getWaznaDo(),
			$keys[5] => $this->getStatus(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = KomunikacjaWersjePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setWersjaNazwa($value);
				break;
			case 2:
				$this->setWersjaOpis($value);
				break;
			case 3:
				$this->setWaznaOd($value);
				break;
			case 4:
				$this->setWaznaDo($value);
				break;
			case 5:
				$this->setStatus($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = KomunikacjaWersjePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setWersjaNazwa($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setWersjaOpis($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setWaznaOd($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setWaznaDo($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setStatus($arr[$keys[5]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(KomunikacjaWersjePeer::DATABASE_NAME);

		if ($this->isColumnModified(KomunikacjaWersjePeer::ID)) $criteria->add(KomunikacjaWersjePeer::ID, $this->id);
		if ($this->isColumnModified(KomunikacjaWersjePeer::WERSJA_NAZWA)) $criteria->add(KomunikacjaWersjePeer::WERSJA_NAZWA, $this->wersja_nazwa);
		if ($this->isColumnModified(KomunikacjaWersjePeer::WERSJA_OPIS)) $criteria->add(KomunikacjaWersjePeer::WERSJA_OPIS, $this->wersja_opis);
		if ($this->isColumnModified(KomunikacjaWersjePeer::WAZNA_OD)) $criteria->add(KomunikacjaWersjePeer::WAZNA_OD, $this->wazna_od);
		if ($this->isColumnModified(KomunikacjaWersjePeer::WAZNA_DO)) $criteria->add(KomunikacjaWersjePeer::WAZNA_DO, $this->wazna_do);
		if ($this->isColumnModified(KomunikacjaWersjePeer::STATUS)) $criteria->add(KomunikacjaWersjePeer::STATUS, $this->status);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(KomunikacjaWersjePeer::DATABASE_NAME);

		$criteria->add(KomunikacjaWersjePeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setWersjaNazwa($this->wersja_nazwa);

		$copyObj->setWersjaOpis($this->wersja_opis);

		$copyObj->setWaznaOd($this->wazna_od);

		$copyObj->setWaznaDo($this->wazna_do);

		$copyObj->setStatus($this->status);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach ($this->getKtabliczkis() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addKtabliczki($relObj->copy($deepCopy));
				}
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new KomunikacjaWersjePeer();
		}
		return self::$peer;
	}

	
	public function clearKtabliczkis()
	{
		$this->collKtabliczkis = null; 	}

	
	public function initKtabliczkis()
	{
		$this->collKtabliczkis = array();
	}

	
	public function getKtabliczkis($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(KomunikacjaWersjePeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collKtabliczkis === null) {
			if ($this->isNew()) {
			   $this->collKtabliczkis = array();
			} else {

				$criteria->add(KtabliczkiPeer::WERSJA_ID, $this->id);

				KtabliczkiPeer::addSelectColumns($criteria);
				$this->collKtabliczkis = KtabliczkiPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(KtabliczkiPeer::WERSJA_ID, $this->id);

				KtabliczkiPeer::addSelectColumns($criteria);
				if (!isset($this->lastKtabliczkiCriteria) || !$this->lastKtabliczkiCriteria->equals($criteria)) {
					$this->collKtabliczkis = KtabliczkiPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastKtabliczkiCriteria = $criteria;
		return $this->collKtabliczkis;
	}

	
	public function countKtabliczkis(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(KomunikacjaWersjePeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collKtabliczkis === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(KtabliczkiPeer::WERSJA_ID, $this->id);

				$count = KtabliczkiPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(KtabliczkiPeer::WERSJA_ID, $this->id);

				if (!isset($this->lastKtabliczkiCriteria) || !$this->lastKtabliczkiCriteria->equals($criteria)) {
					$count = KtabliczkiPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collKtabliczkis);
				}
			} else {
				$count = count($this->collKtabliczkis);
			}
		}
		return $count;
	}

	
	public function addKtabliczki(Ktabliczki $l)
	{
		if ($this->collKtabliczkis === null) {
			$this->initKtabliczkis();
		}
		if (!in_array($l, $this->collKtabliczkis, true)) { 			array_push($this->collKtabliczkis, $l);
			$l->setKomunikacjaWersje($this);
		}
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collKtabliczkis) {
				foreach ((array) $this->collKtabliczkis as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} 
		$this->collKtabliczkis = null;
	}

} 