<?php


abstract class BaseKwiaty extends BaseObject  implements Persistent {


  const PEER = 'KwiatyPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $nazwawiaty;

	
	protected $lok_x;

	
	protected $lok_y;

	
	protected $lok_z;

	
	protected $komunikat;

	
	protected $ikona;

	
	protected $status;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->status = 0;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getNazwawiaty()
	{
		return $this->nazwawiaty;
	}

	
	public function getLokX()
	{
		return $this->lok_x;
	}

	
	public function getLokY()
	{
		return $this->lok_y;
	}

	
	public function getLokZ()
	{
		return $this->lok_z;
	}

	
	public function getKomunikat()
	{
		return $this->komunikat;
	}

	
	public function getIkona()
	{
		return $this->ikona;
	}

	
	public function getStatus()
	{
		return $this->status;
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = KwiatyPeer::ID;
		}

		return $this;
	} 
	
	public function setNazwawiaty($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->nazwawiaty !== $v) {
			$this->nazwawiaty = $v;
			$this->modifiedColumns[] = KwiatyPeer::NAZWAWIATY;
		}

		return $this;
	} 
	
	public function setLokX($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->lok_x !== $v) {
			$this->lok_x = $v;
			$this->modifiedColumns[] = KwiatyPeer::LOK_X;
		}

		return $this;
	} 
	
	public function setLokY($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->lok_y !== $v) {
			$this->lok_y = $v;
			$this->modifiedColumns[] = KwiatyPeer::LOK_Y;
		}

		return $this;
	} 
	
	public function setLokZ($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->lok_z !== $v) {
			$this->lok_z = $v;
			$this->modifiedColumns[] = KwiatyPeer::LOK_Z;
		}

		return $this;
	} 
	
	public function setKomunikat($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->komunikat !== $v) {
			$this->komunikat = $v;
			$this->modifiedColumns[] = KwiatyPeer::KOMUNIKAT;
		}

		return $this;
	} 
	
	public function setIkona($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->ikona !== $v) {
			$this->ikona = $v;
			$this->modifiedColumns[] = KwiatyPeer::IKONA;
		}

		return $this;
	} 
	
	public function setStatus($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->status !== $v || $v === 0) {
			$this->status = $v;
			$this->modifiedColumns[] = KwiatyPeer::STATUS;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(KwiatyPeer::STATUS))) {
				return false;
			}

			if ($this->status !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->nazwawiaty = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->lok_x = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->lok_y = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->lok_z = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->komunikat = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->ikona = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->status = ($row[$startcol + 7] !== null) ? (int) $row[$startcol + 7] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 8; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Kwiaty object", $e);
		}
	}

	
	public function ensureConsistency()
	{

	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(KwiatyPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = KwiatyPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(KwiatyPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			KwiatyPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(KwiatyPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			KwiatyPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			if ($this->isNew() ) {
				$this->modifiedColumns[] = KwiatyPeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = KwiatyPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += KwiatyPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = KwiatyPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = KwiatyPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNazwawiaty();
				break;
			case 2:
				return $this->getLokX();
				break;
			case 3:
				return $this->getLokY();
				break;
			case 4:
				return $this->getLokZ();
				break;
			case 5:
				return $this->getKomunikat();
				break;
			case 6:
				return $this->getIkona();
				break;
			case 7:
				return $this->getStatus();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = KwiatyPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNazwawiaty(),
			$keys[2] => $this->getLokX(),
			$keys[3] => $this->getLokY(),
			$keys[4] => $this->getLokZ(),
			$keys[5] => $this->getKomunikat(),
			$keys[6] => $this->getIkona(),
			$keys[7] => $this->getStatus(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = KwiatyPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNazwawiaty($value);
				break;
			case 2:
				$this->setLokX($value);
				break;
			case 3:
				$this->setLokY($value);
				break;
			case 4:
				$this->setLokZ($value);
				break;
			case 5:
				$this->setKomunikat($value);
				break;
			case 6:
				$this->setIkona($value);
				break;
			case 7:
				$this->setStatus($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = KwiatyPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNazwawiaty($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setLokX($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setLokY($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setLokZ($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setKomunikat($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setIkona($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setStatus($arr[$keys[7]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(KwiatyPeer::DATABASE_NAME);

		if ($this->isColumnModified(KwiatyPeer::ID)) $criteria->add(KwiatyPeer::ID, $this->id);
		if ($this->isColumnModified(KwiatyPeer::NAZWAWIATY)) $criteria->add(KwiatyPeer::NAZWAWIATY, $this->nazwawiaty);
		if ($this->isColumnModified(KwiatyPeer::LOK_X)) $criteria->add(KwiatyPeer::LOK_X, $this->lok_x);
		if ($this->isColumnModified(KwiatyPeer::LOK_Y)) $criteria->add(KwiatyPeer::LOK_Y, $this->lok_y);
		if ($this->isColumnModified(KwiatyPeer::LOK_Z)) $criteria->add(KwiatyPeer::LOK_Z, $this->lok_z);
		if ($this->isColumnModified(KwiatyPeer::KOMUNIKAT)) $criteria->add(KwiatyPeer::KOMUNIKAT, $this->komunikat);
		if ($this->isColumnModified(KwiatyPeer::IKONA)) $criteria->add(KwiatyPeer::IKONA, $this->ikona);
		if ($this->isColumnModified(KwiatyPeer::STATUS)) $criteria->add(KwiatyPeer::STATUS, $this->status);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(KwiatyPeer::DATABASE_NAME);

		$criteria->add(KwiatyPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNazwawiaty($this->nazwawiaty);

		$copyObj->setLokX($this->lok_x);

		$copyObj->setLokY($this->lok_y);

		$copyObj->setLokZ($this->lok_z);

		$copyObj->setKomunikat($this->komunikat);

		$copyObj->setIkona($this->ikona);

		$copyObj->setStatus($this->status);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new KwiatyPeer();
		}
		return self::$peer;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
	}

} 